
// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#include <sbkpep.h>
#include <sbkpepbuffer.h>

#define PYSIDE6_COMOPT_COMPRESS 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqobject.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <pysideqenum.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "kcalendarcore_python.h"

// main header
#include "kcalendarcore_calstorage_wrapper.h"

// Wrappers providing overrides
#include "kcalendarcore_calendarlistmodel_wrapper.h"
#include "kcalendarcore_incidence_wrapper.h"

// Argument includes
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>

using namespace KCalendarCore;

extern "C" {
static PyTypeObject *Sbk_KCalendarCore_CalStorage_TypeF(void)
{
    return SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CalStorage_IDX].type;
}
} // extern "C"

// Native ---------------------------------------------------------

void CalStorageWrapper::resetPyMethodCache()
{
    std::fill(m_PyMethodCache.begin(), m_PyMethodCache.end(), nullptr);
}

void CalStorageWrapper::childEvent(::QChildEvent * event)
{
    static const char *funcName = "childEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[0], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::childEvent(event);
    }
    CalendarListModelWrapper::sbk_o_childEvent("CalStorage", funcName, gil, pyOverride, event);
}

bool CalStorageWrapper::close()
{
    static const char *funcName = "close";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[1], nameCache));
    if (pyOverride.isNull()) {
        gil.acquire();
        Shiboken::Errors::setPureVirtualMethodError("CalStorage.close");
        return false;
    }
    return IncidenceWrapper::sbk_o_supportsGroupwareCommunication("CalStorage", funcName, gil, pyOverride);
}

void CalStorageWrapper::connectNotify(const ::QMetaMethod & signal)
{
    static const char *funcName = "connectNotify";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[2], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::connectNotify(signal);
    }
    CalendarListModelWrapper::sbk_o_connectNotify("CalStorage", funcName, gil, pyOverride, signal);
}

void CalStorageWrapper::customEvent(::QEvent * event)
{
    static const char *funcName = "customEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[3], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::customEvent(event);
    }
    CalendarListModelWrapper::sbk_o_customEvent("CalStorage", funcName, gil, pyOverride, event);
}

void CalStorageWrapper::disconnectNotify(const ::QMetaMethod & signal)
{
    static const char *funcName = "disconnectNotify";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[4], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::disconnectNotify(signal);
    }
    CalendarListModelWrapper::sbk_o_connectNotify("CalStorage", funcName, gil, pyOverride, signal);
}

bool CalStorageWrapper::event(::QEvent * event)
{
    static const char *funcName = "event";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[5], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::event(event);
    }
    return CalendarListModelWrapper::sbk_o_event("CalStorage", funcName, gil, pyOverride, event);
}

bool CalStorageWrapper::eventFilter(::QObject * watched, ::QEvent * event)
{
    static const char *funcName = "eventFilter";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[6], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::eventFilter(watched, event);
    }
    return CalendarListModelWrapper::sbk_o_eventFilter("CalStorage", funcName, gil, pyOverride, watched, event);
}

bool CalStorageWrapper::load()
{
    static const char *funcName = "load";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[7], nameCache));
    if (pyOverride.isNull()) {
        gil.acquire();
        Shiboken::Errors::setPureVirtualMethodError("CalStorage.load");
        return false;
    }
    return IncidenceWrapper::sbk_o_supportsGroupwareCommunication("CalStorage", funcName, gil, pyOverride);
}

bool CalStorageWrapper::open()
{
    static const char *funcName = "open";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[8], nameCache));
    if (pyOverride.isNull()) {
        gil.acquire();
        Shiboken::Errors::setPureVirtualMethodError("CalStorage.open");
        return false;
    }
    return IncidenceWrapper::sbk_o_supportsGroupwareCommunication("CalStorage", funcName, gil, pyOverride);
}

bool CalStorageWrapper::save()
{
    static const char *funcName = "save";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[9], nameCache));
    if (pyOverride.isNull()) {
        gil.acquire();
        Shiboken::Errors::setPureVirtualMethodError("CalStorage.save");
        return false;
    }
    return IncidenceWrapper::sbk_o_supportsGroupwareCommunication("CalStorage", funcName, gil, pyOverride);
}

void CalStorageWrapper::timerEvent(::QTimerEvent * event)
{
    static const char *funcName = "timerEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_KCalendarCore_CalStorage_TypeF(), gil, funcName, m_PyMethodCache[10], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::timerEvent(event);
    }
    CalendarListModelWrapper::sbk_o_timerEvent("CalStorage", funcName, gil, pyOverride, event);
}

const QMetaObject *CalStorageWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject != nullptr)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return KCalendarCore::CalStorage::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int CalStorageWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = KCalendarCore::CalStorage::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *CalStorageWrapper::qt_metacast(const char *_clname)
{
    if (_clname == nullptr)
        return {};
    if (SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this)) {
        auto *obSelf = reinterpret_cast<PyObject *>(pySelf);
        if (PySide::inherits(Py_TYPE(obSelf), _clname))
            return static_cast<void *>(const_cast< CalStorageWrapper *>(this));
    }
    return KCalendarCore::CalStorage::qt_metacast(_clname);
}

CalStorageWrapper::~CalStorageWrapper()
{
    auto *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this, Sbk_KCalendarCore_CalStorage_TypeF());
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int Sbk_KCalendarCore_CalStorage_Init(PyObject *, PyObject *, PyObject *)
{
    Shiboken::Errors::setInstantiateNonConstructible("CalStorage");
    return -1;
}

static PyObject *Sbk_KCalendarCore_CalStorageFunc_close(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::KCalendarCore::CalStorage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CalStorage_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // CalStorage::close()->bool
        if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
            Shiboken::Errors::setPureVirtualMethodError("CalStorage.close");
            return {};
        }
        bool cppResult = cppSelf->close();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_KCalendarCore_CalStorageFunc_load(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::KCalendarCore::CalStorage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CalStorage_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // CalStorage::load()->bool
        if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
            Shiboken::Errors::setPureVirtualMethodError("CalStorage.load");
            return {};
        }
        bool cppResult = cppSelf->load();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_KCalendarCore_CalStorageFunc_open(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::KCalendarCore::CalStorage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CalStorage_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // CalStorage::open()->bool
        if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
            Shiboken::Errors::setPureVirtualMethodError("CalStorage.open");
            return {};
        }
        bool cppResult = cppSelf->open();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_KCalendarCore_CalStorageFunc_save(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    [[maybe_unused]] auto *cppSelf = reinterpret_cast< ::KCalendarCore::CalStorage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CalStorage_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // CalStorage::save()->bool
        if (Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))) {
            Shiboken::Errors::setPureVirtualMethodError("CalStorage.save");
            return {};
        }
        bool cppResult = cppSelf->save();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}


static const char *Sbk_KCalendarCore_CalStorage_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_KCalendarCore_CalStorage_methods[] = {
    {"close", reinterpret_cast<PyCFunction>(Sbk_KCalendarCore_CalStorageFunc_close), METH_NOARGS, nullptr},
    {"load", reinterpret_cast<PyCFunction>(Sbk_KCalendarCore_CalStorageFunc_load), METH_NOARGS, nullptr},
    {"open", reinterpret_cast<PyCFunction>(Sbk_KCalendarCore_CalStorageFunc_open), METH_NOARGS, nullptr},
    {"save", reinterpret_cast<PyCFunction>(Sbk_KCalendarCore_CalStorageFunc_save), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_KCalendarCore_CalStorage_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value != nullptr && PyCallable_Check(value) != 0) {
        auto plain_inst = reinterpret_cast< ::KCalendarCore::CalStorage *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CalStorage_IDX]), reinterpret_cast<SbkObject *>(self)));
        auto *inst = dynamic_cast<CalStorageWrapper *>(plain_inst);
        if (inst != nullptr)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_KCalendarCore_CalStorage_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PyType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_KCalendarCore_CalStorage_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PyType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}

// Class Definition -----------------------------------------------
extern "C" {

static PyType_Slot Sbk_KCalendarCore_CalStorage_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_KCalendarCore_CalStorage_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_KCalendarCore_CalStorage_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_KCalendarCore_CalStorage_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_KCalendarCore_CalStorage_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_KCalendarCore_CalStorage_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkDummyNew /* PYSIDE-595: Prevent replacement of "0" with base->tp_new. */)},
    {0, nullptr}
};
static PyType_Spec Sbk_KCalendarCore_CalStorage_spec = {
    "1:KCalendarCore.KCalendarCore.CalStorage",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_KCalendarCore_CalStorage_slots
};

} //extern "C"

static void *Sbk_KCalendarCore_CalStorage_typeDiscovery([[maybe_unused]] void *cptr, [[maybe_unused]] PyTypeObject *instanceType)
{
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::KCalendarCore::CalStorage *>(reinterpret_cast< ::QObject *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void CalStorage_PythonToCpp_CalStorage_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_KCalendarCore_CalStorage_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_CalStorage_PythonToCpp_CalStorage_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_KCalendarCore_CalStorage_TypeF()))
        return CalStorage_PythonToCpp_CalStorage_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *CalStorage_PTR_CppToPython_CalStorage(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::KCalendarCore::CalStorage *>(const_cast<void *>(cppIn)), Sbk_KCalendarCore_CalStorage_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *KCalendarCore_CalStorage_SignatureStrings[] = {
    "KCalendarCore.KCalendarCore.CalStorage.close(self)->bool",
    "KCalendarCore.KCalendarCore.CalStorage.load(self)->bool",
    "KCalendarCore.KCalendarCore.CalStorage.open(self)->bool",
    "KCalendarCore.KCalendarCore.CalStorage.save(self)->bool",
    nullptr}; // Sentinel
#else
static constexpr size_t KCalendarCore_CalStorage_SignatureByteSize = 74;
static constexpr uint8_t KCalendarCore_CalStorage_SignatureBytes[74] = {
    0x78, 0xda, 0xf3, 0x76, 0x4e, 0xcc, 0x49, 0xcd, 0x4b, 0x49, 0x2c, 0x72, 0xce, 0x2f, 0x4a, 0xd5,
    0xf3, 0x46, 0xe1, 0x01, 0x39, 0xc1, 0x25, 0xf9, 0x45, 0x89, 0xe9, 0xa9, 0x7a, 0xc9, 0x39, 0xf9,
    0xc5, 0xa9, 0x1a, 0xc5, 0xa9, 0x39, 0x69, 0x9a, 0xba, 0x76, 0x49, 0xf9, 0xf9, 0x39, 0x5c, 0xde,
    0xc4, 0x69, 0xcc, 0xc9, 0x4f, 0x4c, 0x21, 0x47, 0x5f, 0x7e, 0x41, 0x6a, 0x1e, 0x39, 0xfa, 0x8a,
    0x13, 0xcb, 0x50, 0xdd, 0x09, 0x00, 0xd1, 0x5a, 0x50, 0xb4
};
#endif

PyTypeObject *init_KCalendarCore_CalStorage(PyObject *enclosingClass)
{
    auto &typeStruct = SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CalStorage_IDX];
    if (typeStruct.type != nullptr)
        return typeStruct.type;

    auto *base1 = reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]));
    Shiboken::AutoDecRef Sbk_KCalendarCore_CalStorage_Type_bases(PyTuple_Pack(1, base1));

    PyTypeObject *pyType = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "CalStorage",
        "KCalendarCore::CalStorage*",
        &Sbk_KCalendarCore_CalStorage_spec,
        &Shiboken::callCppDestructor< KCalendarCore::CalStorage >,
        Sbk_KCalendarCore_CalStorage_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass);
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, KCalendarCore_CalStorage_SignatureStrings);
#else
    InitSignatureBytes(pyType, KCalendarCore_CalStorage_SignatureBytes, KCalendarCore_CalStorage_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_KCalendarCore_CalStorage_PropertyStrings);
    typeStruct.type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        CalStorage_PythonToCpp_CalStorage_PTR,
        is_CalStorage_PythonToCpp_CalStorage_PTR_Convertible,
        CalStorage_PTR_CppToPython_CalStorage);

    Shiboken::Conversions::registerConverterName(converter, "KCalendarCore::CalStorage");
    Shiboken::Conversions::registerConverterName(converter, "KCalendarCore::CalStorage*");
    Shiboken::Conversions::registerConverterName(converter, "KCalendarCore::CalStorage&");
    Shiboken::Conversions::registerConverterAlias(converter, "CalStorage");
    Shiboken::Conversions::registerConverterAlias(converter, "CalStorage*");
    Shiboken::Conversions::registerConverterAlias(converter, "CalStorage&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::KCalendarCore::CalStorage).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(CalStorageWrapper).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(pyType, &Sbk_KCalendarCore_CalStorage_typeDiscovery);

    Shiboken::ObjectType::setSubTypeInitHook(pyType, &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(pyType, &::KCalendarCore::CalStorage::staticMetaObject, sizeof(CalStorageWrapper));

    return pyType;
}
